{
 "metadata": {
  "name": ""
 },
 "nbformat": 3,
 "nbformat_minor": 0,
 "worksheets": [
  {
   "cells": [
    {
     "cell_type": "heading",
     "level": 1,
     "metadata": {},
     "source": [
      "3: Ordered Arrays"
     ]
    },
    {
     "cell_type": "heading",
     "level": 2,
     "metadata": {},
     "source": [
      "Example 1: Page 56"
     ]
    },
    {
     "cell_type": "code",
     "collapsed": false,
     "input": [
      "def find(searchKey):\n",
      "\tlowerBound = 0\n",
      "\tupperBound = nElems - 1\n",
      "\n",
      "\twhile(True):\n",
      "\t\tcurIn = (lowerBound + upperBound) / 2\n",
      "\t\tif v[curIn] == searchKey:\n",
      "\t\t\treturn curIn\t#found it\n",
      "\t\telif lowerBound > upperBound:\n",
      "\t\t\treturn nElems\t#can't find it\n",
      "\t\telse:\t#divide range\n",
      "\t\t\tif v[curIn] < searchKey:\n",
      "\t\t\t\tlowerBound = curIn + 1\t#it's in upper half\n",
      "\t\t\telse:\n",
      "\t\t\t\tupperBound = curIn - 1\t#it's in lower half\n",
      "\t\t#end else divide range\n",
      "\t#end while\n",
      "#end find()"
     ],
     "language": "python",
     "metadata": {},
     "outputs": [],
     "prompt_number": 1
    },
    {
     "cell_type": "heading",
     "level": 2,
     "metadata": {},
     "source": [
      "Example 2: Page 58"
     ]
    },
    {
     "cell_type": "code",
     "collapsed": false,
     "input": [
      "#demonstrates ordered array class\n",
      "class OrdArray:\n",
      "\tdef __init__(self):\t#special method to create objects\n",
      "\t#with instances customized to a specific initial state\n",
      "\n",
      "\t\t#since private instance variables don't exist in Python,\n",
      "\t\t#hence using a convention: name prefixed with an underscore, to treat them as non-public part\n",
      "\t\tself._v = []\t#list _v\n",
      "\n",
      "\tdef getSize(self):\t#return number of elements\n",
      "\t\treturn len(self._v)\n",
      "\n",
      "\tdef find(self, searchKey):\n",
      "\t\tnElems = len(self._v)\n",
      "\t\tlowerBound = 0\n",
      "\t\tupperBound = nElems - 1\n",
      "\n",
      "\t\twhile(True):\n",
      "\t\t\tcurIn = (lowerBound + upperBound) / 2\n",
      "\t\t\tif self._v[curIn] == searchKey:\n",
      "\t\t\t\treturn curIn\t#found it\n",
      "\t\t\telif lowerBound > upperBound:\n",
      "\t\t\t\treturn nElems\t#can't find it\n",
      "\t\t\telse:\t#divide range\n",
      "\t\t\t\tif self._v[curIn] < searchKey:\n",
      "\t\t\t\t\tlowerBound = curIn + 1\t#it's in upper half\n",
      "\t\t\t\telse:\n",
      "\t\t\t\t\tupperBound = curIn - 1\t#it's in lower half\n",
      "\t\t\t#end else divide range\n",
      "\t\t#end while\n",
      "\t#end find()\n",
      "\n",
      "\tdef insert(self, value):\t#put element into array\n",
      "\t\tj = 0\n",
      "\t\tfor j, val in enumerate(self._v):\n",
      "\t\t\tif val > value:\n",
      "\t\t\t\tbreak\n",
      "\t\telse:\n",
      "\t\t\tj += 1\n",
      "\n",
      "\t\tself._v.insert(j, value)\t#inserting it\n",
      "\n",
      "\tdef remove(self, value):\t#remove element from array\n",
      "\t\ttry:\n",
      "\t\t\tself._v.remove(value)\n",
      "\t\t\treturn True\t#found it\n",
      "\t\texcept ValueError:\t#can't find it\n",
      "\t\t\treturn False\n",
      "\n",
      "\tdef display(self):\t#display array contents\n",
      "\t\tprint self._v\t#display it\n",
      "#end class OrdArray\n",
      "\n",
      "arr = OrdArray()\t#create the array\n",
      "\n",
      "arr.insert(77)\t#insert 10 items\n",
      "arr.insert(99)\n",
      "arr.insert(44)\n",
      "arr.insert(55)\n",
      "arr.insert(22)\n",
      "arr.insert(88)\n",
      "arr.insert(11)\n",
      "arr.insert(0)\n",
      "arr.insert(66)\n",
      "arr.insert(33)\n",
      "\n",
      "searchKey = 55\t#search for item\n",
      "if arr.find(searchKey) != arr.getSize():\n",
      "\tprint 'Found', searchKey\n",
      "else:\n",
      "\tprint \"Can't Find\", searchKey\n",
      "\n",
      "arr.display()\t#dislay items\n",
      "\n",
      "print 'Deleting 0, 55, and 99'\n",
      "arr.remove(0)\t#delete 3 items\n",
      "arr.remove(55)\n",
      "arr.remove(99)\n",
      "\n",
      "arr.display()\t#display items again\n",
      "#end"
     ],
     "language": "python",
     "metadata": {},
     "outputs": [
      {
       "output_type": "stream",
       "stream": "stdout",
       "text": [
        "Found 55\n",
        "[0, 11, 22, 33, 44, 55, 66, 77, 88, 99]\n",
        "Deleting 0, 55, and 99\n",
        "[11, 22, 33, 44, 66, 77, 88]\n"
       ]
      }
     ],
     "prompt_number": 2
    },
    {
     "cell_type": "heading",
     "level": 2,
     "metadata": {},
     "source": [
      "Example 3: Page 64"
     ]
    },
    {
     "cell_type": "code",
     "collapsed": false,
     "input": [
      "class person:\n",
      "\t\"\"\"A simple person class\"\"\"\n",
      "\tdef __init__(self, last, first, a):\t#special method to create objects\n",
      "\t#with instances customized to a specific initial state\n",
      "\t\t\n",
      "\t\t#since private instance variables don't exist in Python,\n",
      "\t\t#hence using a convention: name prefixed with an underscore, to treat them as non-public part\n",
      "\t\tself._lastName = last\n",
      "\t\tself._firstName = first\n",
      "\t\tself._age = a\n",
      "\n",
      "\tdef displayPerson(self):\n",
      "\t\tprint '\tLast name:', self._lastName\n",
      "\t\tprint ', First name:', self._firstName\n",
      "\t\tprint ', Age:', self._age\n",
      "\n",
      "\tdef getLast(self):\n",
      "\t\treturn self._lastName\t#get last name\n",
      "#end class Person"
     ],
     "language": "python",
     "metadata": {},
     "outputs": [],
     "prompt_number": 3
    },
    {
     "cell_type": "heading",
     "level": 2,
     "metadata": {},
     "source": [
      "Example 4: Page 65"
     ]
    },
    {
     "cell_type": "code",
     "collapsed": false,
     "input": [
      "#data items as class objects\n",
      "class Person:\n",
      "\t\"\"\"A simple person class\"\"\"\n",
      "\tdef __init__(self, last, first, a):\t#special method to create objects\n",
      "\t#with instances customized to a specific initial state\n",
      "\t\t\n",
      "\t\t#since private instance variables don't exist in Python,\n",
      "\t\t#hence using a convention: name prefixed with an underscore, to treat them as non-public part\n",
      "\t\tself._lastName = last\n",
      "\t\tself._firstName = first\n",
      "\t\tself._age = a\n",
      "\n",
      "\tdef displayPerson(self):\n",
      "\t\tprint '\tLast name:', self._lastName, ', First name:', self._firstName, ', Age:', self._age\n",
      "\n",
      "\tdef getLast(self):\n",
      "\t\treturn self._lastName\t#get last name\n",
      "#end class Person\n",
      "\n",
      "class ClassDataArray:\n",
      "\t#since private instance variables don't exist in Python,\n",
      "\t#hence using a convention: name prefixed with an underscore, to treat them as non-public part\n",
      "\tdef __init__(self):\n",
      "\t\tself._v = []\t#list to store Person type items\n",
      "\n",
      "\tdef __del__(self):\t#destructor\n",
      "\t\tdel self._v[:]\t#delete each element\n",
      "\n",
      "\tdef find(self, searchName):\t#find specified value\n",
      "\t\tfor j, val in enumerate(self._v):\t#for each element\n",
      "\t\t\tif val._lastName == searchName:\t#found item?\n",
      "\t\t\t\tbreak\t#exit loop before end\n",
      "\t\telse:\n",
      "\t\t\tj += 1\n",
      "\n",
      "\t\tif j == len(self._v):\t#gone to end?\n",
      "\t\t\treturn None\t#yes, can't find it\n",
      "\t\telse:\n",
      "\t\t\treturn self._v[j]\t#no, found it\n",
      "\t#end find\n",
      "\n",
      "\tdef insert(self, last, first, age):\t#put person into the array\n",
      "\t\tself._v.append(Person(last, first, age))\n",
      "\n",
      "\tdef remove(self, searchName):\t#delete person from array\n",
      "\t\tfor j, val in enumerate(self._v):\t#look for it\n",
      "\t\t\tif val._lastName == searchName:\n",
      "\t\t\t\tbreak\n",
      "\t\telse:\n",
      "\t\t\tj += 1\n",
      "\n",
      "\t\tif j == len(self._v):\t#can't find it\n",
      "\t\t\treturn False\n",
      "\t\telse:\t#found it\n",
      "\t\t\tdel self._v[j]\t#delete Person object\n",
      "\t\t\treturn True\n",
      "\n",
      "\tdef displayA(self):\t#displays array contents\n",
      "\t\tfor j in self._v:\t#for each element,\n",
      "\t\t\tj.displayPerson()\t#display it\n",
      "#end class ClassDataArray\n",
      "\n",
      "arr = ClassDataArray()\t#array\n",
      "\n",
      "arr.insert('Evans', 'Patty', 24)\t#insert 10 items\n",
      "arr.insert('Smith', 'Lorraine', 37)\n",
      "arr.insert('Yee', 'Tom', 43)\n",
      "arr.insert('Adams', 'Henry', 63)\n",
      "arr.insert('Hashimoto', 'Sato', 21)\n",
      "arr.insert('Stimson', 'Henry', 29)\n",
      "arr.insert('Velasquez', 'Jose', 72)\n",
      "arr.insert('Lamarque', 'Henry', 54)\n",
      "arr.insert('Vang', 'Minh', 22)\n",
      "arr.insert('Creswell', 'Lucinda', 18)\n",
      "\n",
      "arr.displayA()\t#display items\n",
      "\n",
      "searchKey = 'Stimson'\t#search for item\n",
      "print 'Searching for Stimson'\n",
      "found = arr.find(searchKey)\n",
      "\n",
      "if found != None:\n",
      "\tprint '\tFound',\n",
      "\tfound.displayPerson()\n",
      "else:\n",
      "\tprint \"\tCan't find\", searchKey\n",
      "\n",
      "print 'Deleting Smith, Yee, and Creswell'\n",
      "arr.remove('Smith')\t#delete 3 items\n",
      "arr.remove('Yee')\n",
      "arr.remove('Creswell')\n",
      "\n",
      "arr.displayA()\t#display items again\n",
      "#end"
     ],
     "language": "python",
     "metadata": {},
     "outputs": [
      {
       "output_type": "stream",
       "stream": "stdout",
       "text": [
        "\tLast name: Evans , First name: Patty , Age: 24\n",
        "\tLast name: Smith , First name: Lorraine , Age: 37\n",
        "\tLast name: Yee , First name: Tom , Age: 43\n",
        "\tLast name: Adams , First name: Henry , Age: 63\n",
        "\tLast name: Hashimoto , First name: Sato , Age: 21\n",
        "\tLast name: Stimson , First name: Henry , Age: 29\n",
        "\tLast name: Velasquez , First name: Jose , Age: 72\n",
        "\tLast name: Lamarque , First name: Henry , Age: 54\n",
        "\tLast name: Vang , First name: Minh , Age: 22\n",
        "\tLast name: Creswell , First name: Lucinda , Age: 18\n",
        "Searching for Stimson\n",
        "\tFound \tLast name: Stimson , First name: Henry , Age: 29\n",
        "Deleting Smith, Yee, and Creswell\n",
        "\tLast name: Evans , First name: Patty , Age: 24\n",
        "\tLast name: Adams , First name: Henry , Age: 63\n",
        "\tLast name: Hashimoto , First name: Sato , Age: 21\n",
        "\tLast name: Stimson , First name: Henry , Age: 29\n",
        "\tLast name: Velasquez , First name: Jose , Age: 72\n",
        "\tLast name: Lamarque , First name: Henry , Age: 54\n",
        "\tLast name: Vang , First name: Minh , Age: 22\n"
       ]
      }
     ],
     "prompt_number": 1
    }
   ],
   "metadata": {}
  }
 ]
}